﻿local L = LibStub("AceLocale-3.0"):GetLocale("Buggers", false)

Buggers = CreateFrame("frame")
local Buggers = Buggers
Buggers:SetScript("OnEvent", function(self, event, ...) if self[event] then return self[event](self, event, ...) end end)
Buggers:RegisterEvent("ADDON_LOADED")
function Buggers:Print(...) ChatFrame1:AddMessage(string.join(" ", "|cFF33FF99Buggers|r:", ...)) end

function Buggers:ADDON_LOADED(event, addon)
	if addon:lower() ~= "buggers" then return end

	defaults = {
		['class'] = {
			cm = 'Default',
		},
		['char'] = {
			cmloc = 'class',
			buggers = {},
		},
		['global'] = {
			--['macros'] = self.macros['GENERAL'],
		}
	}
	self.db = LibStub("AceDB-3.0"):New("BuggersDB", defaults, 'class')

	self:UnregisterEvent("ADDON_LOADED")
	self.ADDON_LOADED = nil
	if IsLoggedIn() then self:PLAYER_LOGIN() else self:RegisterEvent("PLAYER_LOGIN") end
	
	-- register SlashCommand
	SLASH_Buggers1 = "/Buggers";
	SlashCmdList["Buggers"] = function()
		InterfaceOptionsFrame_OpenToCategory(self.optframe.Buggers)
	end
end

function Buggers:PLAYER_LOGIN()
	if GetMacroIndexByName("Buggers") == 0 then
		CreateMacro("Buggers", 1, '')
	end
	self:Scan()
	self:RegisterEvent("PLAYER_REGEN_DISABLED")
	self:RegisterEvent("PLAYER_REGEN_ENABLED")
	self:RegisterEvent("COMPANION_LEARNED")
	self:RegisterEvent("UNIT_SPELLCAST_SUCCEEDED")
	self.PLAYER_LOGIN = nil
	self:UpdateOptions()
end

function Buggers:PLAYER_REGEN_DISABLED()
	--self:CombatMacro()
end

function Buggers:PLAYER_REGEN_ENABLED()
	--self:SelectMacro()
end

function Buggers:COMPANION_LEARNED()
	self:Scan()
end

function Buggers:UNIT_SPELLCAST_SUCCEEDED(event, arg1, arg2)
	if arg1 == 'player' and self.db.char.buggers[arg2] then
		self:UpdateMacro()
	end
end

function Buggers:UpdateMacro()
	local bugs = {}
	for k, priority in pairs(self.db.char.buggers) do
		if priority ~= 0 then
			for i=1, priority do
				bugs[#bugs+1] = k
			end
		end
	end
	EditMacro(GetMacroIndexByName("Buggers"), "Buggers", 1, string.format('#showtooltip\n/cast %s', bugs[math.random(1,#bugs)]))
end

function Buggers:Scan()
	local creatureName, creatureSpellID, mounttype, mountspeed
	for id = 1,GetNumCompanions("CRITTER") do
		creatureSpellID= select(3, GetCompanionInfo("CRITTER", id))
		creatureName = GetSpellInfo(creatureSpellID);
		self.db.char.buggers[creatureName] = self.db.char.buggers[creatureName] or 5
	end
	self:UpdateMacro()
	self:UpdateOptions()
end
