local Buggers = Buggers
local L = LibStub("AceLocale-3.0"):GetLocale("Buggers", false)

Buggers.Option = {	
	type="group",
	width = 'fill',
	handler = Buggers,
	args={
	},
}

function Buggers:UpdateOptions()
	local mounts = {}
	for k in pairs(self.db.char.buggers) do
		mounts[#mounts + 1] = k
	end
	table.sort(mounts)
	for i, mountname in ipairs(mounts) do
		self.Option.args[tostring(i)] = self:CreateRange(mountname, i)
	end
end

function Buggers:GetRange(info)
	return self.db.char.buggers[info.option.name]
end

function Buggers:SetRange(info, num)
	self.db.char.buggers[info.option.name] = num
end

function Buggers:CreateRange(mountname,ordernum)
	local Range = {
			type = 'range',
			name = mountname,
			order = ordernum,
			width = 'full',
			min = 0,
			max = 10,
			step = 1,
			get = 'GetRange',
			set = 'SetRange',
		}
	return Range
end

Buggers.optframe = {}
LibStub("AceConfig-3.0"):RegisterOptionsTable('Buggers', Buggers.Option)
Buggers.optframe.Buggers = LibStub("AceConfigDialog-3.0"):AddToBlizOptions('Buggers', 'Buggers')
-- function addapted from the RegisterModuleOptions function in Mapster
function Buggers:RegisterModuleOptions(name, optionTbl, displayName)
	local cname = "Buggers"..name
	LibStub("AceConfigRegistry-3.0"):RegisterOptionsTable(cname, optionTbl)
	self.optframe[name] = LibStub("AceConfigDialog-3.0"):AddToBlizOptions(cname, displayName, "Buggers")
end
